﻿Imports System.Windows.Forms
Imports System.IO
Imports fishfact3.Cybele.Thinfinity

Public Class FormMain
    Private mVirualUI As VirtualUI
    Private mRemoteDB As IJSObject = Nothing

    Public Sub New()
        InitializeComponent()
        AppDomain.CurrentDomain.SetData("DataDirectory", Path.GetFullPath("..\\..\\..\\..\\data"))

        mVirualUI = New VirtualUI()
        mVirualUI.Start()
    End Sub

    Public ReadOnly Property RemoteDB() As IJSObject
        Get
            If mRemoteDB Is Nothing Then
                ' Creates the "db" JSObject
                mRemoteDB = New JSObject("db")

                Dim allowedTypes = New Type() {GetType(String), GetType(Byte), GetType(Char), GetType(Decimal), GetType(Double)}

                ' Iterates over the dataset fields
                For Each column As DataColumn In dbdemosDataSet.BIOLIFE.Columns
                    ' Bypasses some data types
                    If Array.IndexOf(allowedTypes, column.DataType) >= 0 Then
                        ' Creates the property with the name of the field.
                        ' Returns a IJSProperty
                        ' Adds a "getter" to the returned IJSProperty (.OnGet)
                        ' The anonymous sub do the actual get
                        mRemoteDB.Properties.Add(column.ColumnName) _
                            .OnGet(New JSBinding( _
                                   Sub(AObj As IJSObject, AProp As IJSProperty)
                                       Dim col As DataColumn = DbdemosDataSet.BIOLIFE.Columns(AProp.Name)
                                       Dim value As String = DbdemosDataSet.BIOLIFE.Rows(BIOLIFEBindingSource.Position)(col).ToString()

                                       If (col.DataType = GetType(String)) OrElse (col.DataType = GetType(Byte)) OrElse (col.DataType = GetType(Char)) Then
                                           AProp.AsString = value
                                       Else
                                           AProp.AsFloat = Single.Parse(value)
                                       End If
                                   End Sub))
                    End If
                Next
                ' Applies the object model and sends it to the web browser
                mRemoteDB.ApplyModel()
            End If
            Return mRemoteDB
        End Get
    End Property

    Private Sub FormMain_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.BIOLIFETableAdapter.Fill(Me.DbdemosDataSet.BIOLIFE)
    End Sub

    Private Sub BIOLIFEBindingSource_PositionChanged(sender As Object, e As EventArgs) Handles BIOLIFEBindingSource.PositionChanged
        ' Calls all RemoteDB's properties "getters"
        RemoteDB.ApplyChanges()
    End Sub
End Class
